Graphics3D 800,600,32,2

AppTitle "Saturnringe Demo"

SetBuffer BackBuffer()

;Parameter
weite#=1000.0									;maximale Entfernung / Skybox Dimensionen
scale#=0.25										;Texturskalierung Skybox
alpha#=0.9										;Alphawert Ringe
speed#=0.01										;Raumschiffgeschwindigkeit

;virtuellen Weltraum erzeugen
skybox=LoadSkyBox("sterne.png",1,scale#,weite#)

;der Weltraum ist dunkelgrau
AmbientLight 32,32,32

;Lichtquelle
light=CreateLight(1)
PositionEntity light,0,0,-10

;Kamera
cam=CreateCamera()
CameraRange cam,.005,weite#*10					;Blickweite anpassen
PositionEntity cam,2,.1,-2						;schne Position einnehmen
RotateEntity cam,0,45,0							;etwas rotieren
CameraZoom cam,2								;Zoom korrigieren

;Sonne bauen
sonne=LoadSprite("sonne.bmp")
PositionEntity sonne,0,0,-500
ScaleSprite sonne,10,10

;Saturn bauen
saturn=CreateSphere(32)							;Saturn ist eine Kugel
ScaleEntity saturn,.2,.2,.2						;vergrssern
saturntex=LoadTexture("saturnmap.jpg")			;Textur laden
EntityTexture saturn,saturntex					;Textur zuweisen

;Ringsystem als Sprite bauen
ringe=LoadSprite("saturnringe.bmp",2)			;Ringe als Sprite laden
ScaleSprite ringe,.6,.6							;vergrssern
SpriteViewMode ringe,2							;Sprite als 3D-Modell behandeln
EntityFX ringe,17								;leuchtend und mit Rckseite (1+16)
RotateEntity ringe,90,0,180						;um 90 drehen und dann einmal herum
EntityAutoFade ringe,1,(weite#/2)				;Ringe sollen bei halber Weite faden
TurnEntity ringe,5,0,0							;Ringe etwas schief stellen
EntityAlpha ringe,alpha#						;Alphawert zuweisen

;Maus in die Mitte
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

;Hauptschleife
While Not KeyHit(1)

	Steuerung(cam,skybox,200,208,203,205,speed#);Steuerungsfunktion
	
	;Kamerapositionen
	If KeyDown(2) Then
		PositionEntity cam,2,.1,-2				;Taste 1: Ausgangsposition
		RotateEntity cam,0,45,0
	EndIf

	If KeyDown(3) Then
		PositionEntity cam,0.24,0.4,1			;Taste 2: Blick auf Sonne
		RotateEntity cam,12.6,-177.4,0
	EndIf

	If KeyDown(4) Then
		PositionEntity cam,0,2,0				;Taste 3: Draufsicht
		RotateEntity cam,89,-88,0
	EndIf

	If KeyDown(5) Then
		PositionEntity cam,0,0.75,1.87			;Taste 4: 2001 Sicht
		RotateEntity cam,13,180,0
	EndIf

	If KeyDown(6) Then
		PositionEntity cam,-5.38,-0.32,-503.3	;Taste 5: Sonne nah
		RotateEntity cam,-14.6,-8.2,0
	EndIf

	;Bewegung
	TurnEntity skybox,.01,.01,.01				;Skybox bewegt sich leicht
	TurnEntity saturn,0,2,0						;Saturn rotiert

	RenderWorld									;Objekte rendern

	;FPS counter
	loops=loops + 1
	If MilliSecs()-time1>500 Then 
		fps#=loops * 2 
		loops=0 
		time1=MilliSecs() 
	End If 	 

	;Textausgabe
	Text 0,0,"Saturnringe Demo"					;Titel
	Text 0,10,"FPS: "+fps#						;FPS Anzeige
	Flip 0										;schneller Flip

Wend

End

;Maus/Tastatursteuerung 
Function Steuerung(cam,skybox,oben,unten,rechts,links,speed#) 

	;Mausbewegung holen
	mxs#=MouseXSpeed()
	mys#=MouseYSpeed()

	;Mauszeiger in die Mitte
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

	;Kamera anhand der Mausbewegung rotieren
	RotateEntity cam,EntityPitch(cam)+(mys#/5),EntityYaw(cam)-(mxs#/5),0

	;Maus/Tastaturabfrage
	If MouseDown(1) Then speed#=speed#*10						;linke Maustaste: 10x schneller
	If MouseDown(2) Then speed#=speed#*20						;rechte Maustaste: 20x schneller
	If KeyDown(oben) Then MoveEntity cam,0,0,speed#
	If KeyDown(unten) Then MoveEntity cam,0,0,-speed#
	If KeyDown(links) Then MoveEntity cam,speed#,0,0
	If KeyDown(rechts) Then MoveEntity cam,-speed#,0,0

	;Skybox mitbewegen
	xx#=EntityX(cam)
	yy#=EntityY(cam)
	zz#=EntityZ(cam)
	PositionEntity skybox,xx#,yy#,zz#	

End Function

;Skybox erstellen
Function LoadSkyBox(file$,filter,scale#,size#) 

		;Mesh erstellen
        m=CreateMesh() 

        ;vorne
        s=CreateSurface(m) 
        AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0 
        AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1 
        AddTriangle s,0,1,2:AddTriangle s,0,2,3 

        ;rechts 
        s=CreateSurface(m) 
        AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0 
        AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1 
        AddTriangle s,0,1,2:AddTriangle s,0,2,3 

        ;hinten 
        s=CreateSurface(m) 
        AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0 
        AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1 
        AddTriangle s,0,1,2:AddTriangle s,0,2,3 

        ;links 
        s=CreateSurface(m) 
        AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0 
        AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1 
        AddTriangle s,0,1,2:AddTriangle s,0,2,3 

        ;oben 
        s=CreateSurface(m) 
        AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0 
        AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1 
        AddTriangle s,0,1,2:AddTriangle s,0,2,3 

		;unten
		s=CreateSurface(m) 
		AddVertex s,-1,-1,-1,1,0
		AddVertex s,+1,-1,-1,1,1
		AddVertex s,+1,-1,+1,0,1
		AddVertex s,-1,-1,+1,0,0
		AddTriangle s,0,1,2
		AddTriangle s,0,2,3

		;Skybox skalieren, nach innen drehen und Filter anwenden
        ScaleMesh m,size#,size#,size#
        FlipMesh m 
        EntityFX m,filter

		;Skybox-Textur laden und zuweisen
		tex=LoadTexture(file$)
		ScaleTexture tex,scale#,scale#
		EntityTexture m,tex

		;Objekt zurckgeben
        Return m 

End Function